Graphics 130,24,0,2
SetBuffer BackBuffer()

Origin 49,0

Dim landScapeY#(100)
Local scrollX#=0

Global player.TFigure
Local dead
Global killCount=0
Global maxKillCount=0

Local drawMode=1
Dim screen(32,24)
Local showScore=1

Type TFigure
	Field x#
	Field y#
	
	Field vy#
	Field vx#
	
	Field dir
	
	Field jump
End Type

Type TStar
	Field x#
	Field y#
	
	Field vx#
	Field vy#
End Type

Type TParticle
	Field x#
	Field y#
	
	Field vx#
	Field vy#
End Type
	
ResetGame()

timer=CreateTimer(60)
While Not KeyHit(1)
	Color 255,255,255
	
	dead=False
	
	scrollX=player\x-16
	For f.TFigure=Each TFigure
		f\vy=f\vy+0.1
		f\y=f\y+f\vy
		f\x=f\x+f\vx
		
		For i=0 To 99
			If i*5<=f\x And (i+1)*5>=f\x
				x1#=i*5
				y1#=landScapeY(i)
				
				x2#=(i+1)*5
				y2#=landScapeY(i+1)
				
				dx#=x2-x1
				dy#=y2-y1
				
				k#=(f\x-x1)/dx
				
				landY#=y1+k*dy
				
				If f\y>landY
					f\y=landY
					f\jump=False
				EndIf
			EndIf
			
			If f=player
				;Line i*5-scrollX,landScapeY(i),(i+1)*5-scrollX,landScapeY(i+1)
				
				If (i*5-scrollX>=0 Or (i+1)*5-scrollX>=0) And (i*5-scrollX<=32 Or (i+1)*5-scrollX<=32)
					x1#=i*5-scrollX
					y1#=landScapeY(i)
					
					x2#=(i+1)*5-scrollX
					y2#=landScapeY(i+1)
					
					dx#=x2-x1
					dy#=y2-y1
					
					For x=i*5-scrollX To (i+1)*5-scrollX
						k#=(x-x1)/dx
						
						landY#=y1+k*dy
						
						For y=0 To landY
							WritePixel x,y,$0000ff
						Next
						For y=landY To 23
							WritePixel x,y,$00ff00
						Next
					Next
				EndIf
			EndIf
		Next
		
		Oval f\x-2-scrollX,f\y-4,4,4
		
		If f<>player
			If Rand(1,100)=42 And f\jump=False
				f\vy=-1.5
				f\jump=1
			EndIf
			
			If RectsOverlap(f\x-2,f\y-2,4,4,player\x-2,player\y-2,4,4)
				dead=True
			EndIf
			
			If f\y>24
				Delete f
			EndIf
		EndIf
		
		If f<>Null
			Color 125,125,125
			
			For t.TStar=Each TStar
				If f=player
					t\vy=t\vy+0.1
					
					t\x=t\x+t\vx
					t\y=t\y+t\vy
					
					Line t\x-2-scrollX,t\y,t\x+2-scrollX,t\y
					Line t\x-scrollX,t\y-2,t\x-scrollX,t\y+2
				Else
					If RectsOverlap(t\x-2,t\y-2,4,4,f\x-2,f\y-2,4,4)
						For k=0 To 10
							p.TParticle=New TParticle
							
							p\x=f\x
							p\y=f\y
							
							p\vx=Rnd(-1.0,1.0)
							p\vy=Rnd(-1.5,-1.0)
						Next
						
						Delete f
						killCount=killCount+1
						
						Exit
					EndIf
				EndIf
				
				If t\y>24
					Delete t
				EndIf
			Next
			
			Color 255,255,255
		EndIf
	Next
	
	Color 255,0,0
	For p.TParticle=Each TParticle
		p\vy=p\vy+0.1
		
		p\x=p\x+p\vx
		p\y=p\y+p\vy
		
		WritePixel p\x-scrollX,p\y,$ff0000
		
		If p\y>24
			Delete p
		EndIf
	Next
	
	Color 25,25,25
	
	If killCount>maxKillCount
		maxKillCount=killCount
	EndIf
	If showScore
		Text 0,0,killCount
		Text 32-Len(maxKillCount)*8,0,maxKillCount
		
		fps=fps+1
		If MilliSecs()-fpsTime>999
			fpsCur=fps
			fpsTime=MilliSecs()
			fps=0
		EndIf
		Text 0,12,fpsCur
	EndIf
	
	Color 0,0,0
	Rect -49,0,49,32
	Rect 32,0,49,32
	
	If drawMode=0
		For x=0 To 31
			For y=0 To 23
				screen(x,y)=ReadPixel(x,y)
			Next
		Next
		
		Cls
		
		LockBuffer BackBuffer()
		For x=0 To 31
			For y=0 To 23
				If screen(x,y)<>0
					r=(screen(x,y) And $FF0000)/$10000
					g=(screen(x,y) And $FF00)/$100
					b=(screen(x,y) And $FF)
					
					Color r,g,b
					
					;Rect x*10,y*10,10,10
					For i=0 To 10
						Line x*10,y*10+i,x*10+10,y*10+i
					Next
				EndIf
			Next
		Next
		UnlockBuffer BackBuffer()
	EndIf
	
	If KeyHit(35)
		showScore=1-showScore
	EndIf
	
	If KeyHit(28)
		drawMode=1-drawMode
		
		If drawMode=1
			Graphics 130,24,0,2
			SetBuffer BackBuffer()
			
			Origin 49,0
		Else
			Graphics 320,240,0,2
			SetBuffer BackBuffer()
		EndIf
	EndIf
	
	player\x=player\x+(KeyDown(205)-KeyDown(203))*0.5
	If player\x<16
		player\x=16
	EndIf
	If player\x>484
		player\x=484
	EndIf
	If KeyDown(205) Or KeyDown(203)
		player\dir=KeyDown(205)-KeyDown(203)
	EndIf
	If Not player\jump
		If KeyDown(200)
			player\vy=-1.5
			player\jump=True
		EndIf
	EndIf
	
	If player\y>24
		dead=True
	EndIf
	
	If KeyDown(29) Or MouseDown(1)
		If MilliSecs()-firetime>100 And player\dir<>0
			s.TStar=New TStar
			
			s\x=player\x
			s\y=player\y
			
			s\vx=player\dir*1.5
			s\vy=0
			
			firetime=MilliSecs()
		EndIf
	Else
		firetime=0
	EndIf
	
	If MilliSecs()-spawntime>1500
		e.TFigure=New TFigure
		
		dir=Rand(0,1)
		
		If dir=0
			e\x=player\x+Rnd(16,32)
			e\y=32
		Else
			e\x=player\x-Rnd(16,32)
			e\y=32
		EndIf
		
		e\vx=Sgn(player\x-e\x)*0.2
		
		spawntime=MilliSecs()
	EndIf
	
	If dead
		ResetGame()
	EndIf
	
	Flip 0
	Cls
	WaitTimer(timer)
Wend End

Function ResetGame()
	SeedRnd(MilliSecs())
	
	For i=0 To 100
		landScapeY(i)=Rnd(16,23)
	Next
	
	Delete Each TFigure
	Delete Each TStar
	Delete Each TParticle
	
	player=New TFigure
	
	player\x=250
	player\y=32
	
	killCount=0
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D