Const MAPSIZE=256

Graphics 800,600

Global Map[,],B[,],VM[,],PRL:TList=New TList,SX,SY,PX=20,PY=20,KS:Int[4],BR:Float=110,BL:TList=New TList,RA,GA

Local Timer:TTimer=CreateTimer(60)

Init()

While Not (KeyHit(KEY_ESCAPE) Or AppTerminate())
	Cls
	
	UserInput()
	UpdateB()
	RenderMap()
	
	TBeast.Update()
	
	If BR<0 EndGame("YOU LOST")
	
	Flip 0
	WaitTimer Timer
Wend
End

Type TCave
	Field ID
	Field Size
	
	Field X
	Field Y
	
	Method Compare(Other:Object)
		Return Size-TCave(Other).Size
	End Method
End Type

Type TBeast
	Field X,Y,Kind,Timer
	
	Method Move(DirX,DirY)
		If Not Map[X+DirX,Y+DirY]
			X:+DirX
			Y:+DirY
			
			If X=PX And Y=PY TOETEN()
		EndIf
	End Method
	
	Method TOETEN()
		BR:+20*Kind
		
		If Kind=1 BL.Remove(Self)
		
		RA=181
		GA=181*(Kind>0)
	End Method
Function Create(X,Y,Kind);V:TBeast=New TBeast;V.X=X;V.Y=Y;V.Kind=Kind;V.Timer=MilliSecs()+Rand(0,100);BL.AddLast(V);End Function
Function Update();For V:TBeast=EachIn BL
If MilliSecs()-V.Timer>200+V.Kind*100 Dir=Rand(-1,1);V.Timer=MilliSecs();If Dir V.Move(Dir,0) Else V.Move(0,Rand(-1,1))
Next;End Function;End Type
Type TTT;Field X,Y,DestX,DestY;Function Create(X,Y,DX,DY);T1:TTT=New TTT;T1.X=X;T1.Y=Y;T1.DestX=DX;T1.DestY=DY;PRL.AddLast T1;End Function;End Type
Function Init();SeedRnd MilliSecs();B=New Int[MAPSIZE,MAPSIZE];VM=New Int[MAPSIZE,MAPSIZE];Map=GenerateMap(MAPSIZE,MAPSIZE);PrepareMap();End Function
Function UserInput();Dir=KeyClick(KEY_RIGHT)-KeyClick(KEY_LEFT);If Dir Move(Dir,0) Else Dir=KeyClick(KEY_DOWN)-KeyClick(KEY_UP);If Dir Move(0,Dir)
If PX-SX<30 SX:+Max(PX-SX-30,-3) ElseIf PX-SX>50 SX:+Min(PX-SX-50,3)
If PY-SY<25 SY:+Max(PY-SY-25,-3) ElseIf PY-SY>35 SY:+Min(PY-SY-35,3)
End Function
Function KeyClick(ID);I=ID-37;If KeyHit(ID) Or (MilliSecs()-KS[I]>125 And KeyDown(ID)) KS[I]=MilliSecs();Return 1
End Function
Function Move(X,Y);If Map[PX+X,PY+Y]=0
PX:+X;PY:+Y
For TP:TTT=EachIn PRL
If PX=TP.X And PY=TP.Y
PX=TP.DestX;PY=TP.DestY;If PX<0 EndGame("YOU WON")
Exit
EndIf
Next
For Beast:TBeast=EachIn BL
If PX=Beast.X And PY=Beast.Y Beast.TOETEN()
Next
EndIf;End Function
Function EndGame(MS$);Cls;SetOrigin 0,0;SetColor 255,255,255;SetScale 5,5;DrawText MS,250,250;SetScale 1,1;Flip 0;FlushKeys;WaitKey;BR=110;PRL=New TList;BL=New TList;Init();End Function
Function RenderMap();SetOrigin -SX*10,-SY*10;For X=Max(SX,0) To Min(SX+80,MAPSIZE)-1;For Y=Max(SY,0) To Min(SY+80,MAPSIZE)-1
If B[X,Y] K=(255/(4-Map[X,Y]*3))/(2-(B[X,Y]=1));SetColor K+RA*(B[X,Y]=1),K+GA*(B[X,Y]=1),K;DrawRect X*10,Y*10,10,10
Next;Next
SetColor 128,0,255;For TP:TTT=EachIn PRL
DrawRect TP.X*10,TP.Y*10,10,10
Next;For Beast:TBeast=EachIn BL
SetColor 128+Beast.Kind*128,64+Beast.Kind*64,0
If B[Beast.X,Beast.Y]=1 DrawRect Beast.X*10,Beast.Y*10,10,10
Next;SetColor 255,255,0;DrawRect PX*10,PY*10,10,10;RA=Max(0,RA-3);GA=Max(0,GA-3);End Function
Function PrepareMap();CaveID=1;CL:TList=New TList
For X=0 To MAPSIZE-1;For Y=0 To MAPSIZE-1
If Not (VM[X,Y]+Map[X,Y])
Count=CountSpace(X,Y,CaveID)
If Count>400 Local C:TCave=New TCave;C.ID=CaveID;C.Size=Count;C.X=X;C.Y=Y;CL.AddLast(C)
CaveID:+1
EndIf
Next;Next;CL.Sort();Local CA:TCave[]=TCave[](CL.ToArray())
For I=0 To CA.Length-1;For X=MAPSIZE-1 To 0 Step -1;For Y=MAPSIZE-1 To 0 Step -1
If VM[X,Y]=CA[I].ID
If I=CA.Length-1 TTT.Create(X,Y,-1,-1) Else TTT.Create(X,Y,CA[I+1].X,CA[I+1].Y)
Goto L
EndIf
Next;Next
#L
Next
PX=CA[0].X;PY=CA[0].Y;For X=0 To MAPSIZE-1 Step 13;For Y=0 To MAPSIZE-1 Step 13
If Not Map[X,Y] TBeast.Create(X,Y,1-2*Sgn(Rand(0,10)))
Next;Next;End Function
Function CountSpace(QX,QY,ID);R=1;VM[QX,QY]=ID;If Not (VM[QX+1,QY]+Map[QX+1,QY]) R:+CountSpace(QX+1,QY,ID)
If Not (VM[QX-1,QY]+Map[QX-1,QY]) R:+CountSpace(QX-1,QY,ID)
If Not (VM[QX,QY+1]+Map[QX,QY+1]) R:+CountSpace(QX,QY+1,ID)
If Not (VM[QX,QY-1]+Map[QX,QY-1]) R:+CountSpace(QX,QY-1,ID)
Return R;End Function
Function GenerateMap[,](W,H);Local MD[W,H],NMD[W,H];For Y=1 To H-2;For X=1 To W-2
MD[X,Y]=Rnd()<=0.5
Next;Next
For I=0 To W-1
MD[I,0]=1;MD[I,H-1]=1;NMD[I,0]=1;NMD[I,H-1]=1
Next
For I=0 To H-1
MD[0,I]=1;MD[W-1,I]=1;NMD[0,I]=1;NMD[W-1,I]=1
Next
For Q=1 To 7;For Y=1 To H-2;For X=1 To W-2
FC=0;NC=0;For I=Max(X-1-(Q<5),0) To Min(X+1+(Q<5),W-1);For T=Max(Y-1-(Q<5),0) To Min(Y+1+(Q<5),H-1)
FC:+MD[I,T]
If Abs(X-I)<2 And Abs(Y-T)<2 NC:+MD[I,T]
Next;Next;If Q<5 NMD[X,Y]=((NC >= 5) Or (FC <= 2)) Else NMD[X,Y]=(NC >= 6)
Next;Next;Local Temp[,]=MD;MD=NMD;NMD=Temp
Next;Return MD;End Function
Function UpdateB()
For X=Max(SX,0) To Min(SX+80,MAPSIZE)-1;For Y=Max(SY,0) To Min(SY+80,MAPSIZE)-1
If (Not LineMapIntersection(PX,PY,X,Y)) And (PX-X)^2+(PY-Y)^2<BR B[X,Y]=1 ElseIf B[X,Y]=1 B[X,Y]=2
Next;Next;End Function
Function LineMapIntersection(X1,Y1,X2,Y2);DX=X2-X1;DY=Y2-Y1;ADX=Abs(DX);ADY=Abs(DY);SDX=Sgn(DX);SDY=Sgn(DY);If ADX>ADY PDX=SDX;DDX=SDX;DDY=SDY;EF=ADY;ES=ADX Else PDY=SDY;DDX=SDX;DDY=SDY;EF=ADX;ES=ADY
X=X1;Y=Y1;E=ES/2;For I=1 To ES
E=E-EF
If E<0 E=E+ES;X=X+DDX;Y=Y+DDY Else X=X+PDX;Y=Y+PDY
If X=X2 And Y=Y2 Exit
If Map[X,Y] Return 1
Next;End Function