;Flugnot v1.0 (BCC #32 "Minimalismus")
;Date: 21.11.2009
;Author: Raoudi - www.blaugrund.org

Graphics3D 320, 240, 32, 2
AppTitle "Flugnot v1.0"
SetBuffer BackBuffer()
SeedRnd MilliSecs()

Global S% = 10
Global TIMER = CreateTimer(30)
Global LEVEL# = 1
Global HEALTH% = 3
Global SX% = 16, SY% = 20

Type bullet
	Field x%, y%
	Field dir%, dmg%
	Field r%, g%, b%
End Type


While Not KeyHit(1)
WaitTimer(TIMER)
Cls


;Update Bullets
For bul.bullet = Each bullet
	If bul\y < 24 And bul\y => 0
		If bul\dir = 1
			bul\y = bul\y + 1
		Else
			bul\y = bul\y - 1
		EndIf
		DrawPixel(bul\x, bul\y, 1, bul\r, bul\g, bul\b)
		If bul\x = SX And bul\y = SY
			HEALTH = HEALTH - bul\dmg
			If bul\dmg > 0 Then DrawPixel(0, 0, 32, 255, 0, 0)
			If bul\dmg < 0 Then DrawPixel(0, 0, 32, 0, 255, 0)
			If HEALTH > 32 Then HEALTH = 32
			
			bul\y = 40
		EndIf
	Else
		Delete bul
	EndIf
Next

;Generate Bullets
If Rand(1, 32 / Int(LEVEL)) = 1 Then CreateBullet(Rand(0, 32), 0, 1, 200, 200, 0, 1)
If Rand(1, 32) = 1 Then CreateBullet(Rand(0, 32), 0, 1, 200, 200, 255, -1)

;Ship
DrawPixel(SX, SY, 1, 200, 200, 255)

If KeyDown(203) And SX > 0 Then SX = SX - 1
If KeyDown(205) And SX < 31 Then SX = SX + 1
If KeyDown(208) And SY < 21 Then SY = SY + 1
If KeyDown(200) And SY > 0 Then SY = SY - 1


;Etc
If LEVEL < 32
	LEVEL = LEVEL + 0.003555
Else
	Victory()
EndIf

If HEALTH < 0
	Fail()
EndIf

For t = 0 To Int(LEVEL)
	DrawPixel(t - 1, 23, 1, 255, 0, 0)
Next

For t = 1 To HEALTH
	DrawPixel(t - 1, 22, 1, 200, 200, 255)
Next

Flip
Wend

End

;Functions
Function DrawPixel(x%, y%, scale% = 1, r% = 255, g% = 255, b% = 255)
	Color r, g, b
	Rect x * S, y * S, S * scale, S * scale
End Function


Function CreateBullet(x%, y%, dir%, r% = 255, g% = 255, b% = 255, dmg% = 1)
	bul.bullet = New bullet
	bul\x = x
	bul\y = y
	bul\dir = dir
	bul\r = r
	bul\g = g
	bul\b = b
	bul\dmg = dmg
	DrawPixel(bul\x, bul\y, 1, bul\r, bul\g, bul\b)
End Function


Function Victory()
	DrawPixel(0, 0, 32, 0, 255, 0)
	
	DrawPixel(12, 8, 2, 0, 0, 0)
	DrawPixel(18, 8, 2, 0, 0, 0)
	
	DrawPixel(10, 16, 2, 0, 0, 0)
	DrawPixel(12, 16, 2, 0, 0, 0)
	DrawPixel(14, 16, 2, 0, 0, 0)
	DrawPixel(16, 16, 2, 0, 0, 0)
	DrawPixel(18, 16, 2, 0, 0, 0)
	DrawPixel(20, 16, 2, 0, 0, 0)
	DrawPixel(9, 14, 2, 0, 0, 0)
	DrawPixel(21, 14, 2, 0, 0, 0)

	
	Flip
	Delay 1000
	FlushKeys()
	WaitKey()
	End
End Function


Function Fail()
	DrawPixel(0, 0, 32, 255, 0, 0)
	
	DrawPixel(12, 8, 2, 0, 0, 0)
	DrawPixel(18, 8, 2, 0, 0, 0)
	
	DrawPixel(10, 16, 2, 0, 0, 0)
	DrawPixel(12, 16, 2, 0, 0, 0)
	DrawPixel(14, 16, 2, 0, 0, 0)
	DrawPixel(16, 16, 2, 0, 0, 0)
	DrawPixel(18, 16, 2, 0, 0, 0)
	DrawPixel(20, 16, 2, 0, 0, 0)
	DrawPixel(9, 18, 2, 0, 0, 0)
	DrawPixel(21, 18, 2, 0, 0, 0)

	SX = 16
	SY = 20
	HEALTH = 3
	LEVEL = 1
	For bul.bullet = Each bullet
		Delete bul
	Next
	
	Flip
	Delay 1000
	FlushKeys()
	WaitKey()
End Function