AppTitle "MINI - BCC # 32"
Graphics 800,600,32,2
Graphics 80,60,32,3
SetBuffer BackBuffer()

Global Gw = GraphicsWidth(),Gh = GraphicsHeight()
Global Ts = 5,level=1,maxlvl=7
Global MW = Gw/Ts,MH = Gh/Ts
Global px=1,py=1,ip
Global hit = LoadSound("sfx\hit.mp3")
Global won = LoadSound("sfx\won.mp3")
Dim m(MW,MH)
LoadLevel("lvl"+level)
While Not KeyDown(1)
	Color 255,255,255
	DrawMap()
	
	If KeyHit(205) Then px=px+CheckF(px,py,1,0)
	If KeyHit(203) Then px=px-CheckF(px,py,-1,0)
	If KeyHit(200) Then py=py-CheckF(px,py,0,-1)
	If KeyHit(208) Then py=py+CheckF(px,py,0,1)
	Oval px*Ts,py*Ts,Ts,Ts
	If KeyHit(38) Then FlushKeys():Locate 0,0:ip = Input("nr: "):Reset(1):level = ip:LoadLevel("lvl"+ip)
	If CWin() Then PlaySound(won):Reset():LoadLevel("lvl"+level)
	If KeyHit(46) Then Reset(1):LoadLevel("lvl"+level)
	Flip
	Cls
Wend

Function DrawMap()
	Local x,y,d
	For x = 0 To MW-1
		For y = 0 To MH-1
			d=0
			If m(x,y)=1 Then d=1:Color 100,100,100
			If d Then Rect x*Ts,y*Ts,Ts,Ts
		Next
	Next
	Local z.ziel
	Color 50,100,50
	For z = Each ziel
		Rect z\x*Ts,z\y*Ts,Ts,Ts
	Next
	Local n.kist
	Color 255,0,0
	For n = Each kist
		Rect n\x*Ts,n\y*Ts,Ts,Ts
		m(n\x,n\y)=1
	Next
	Color 255,255,255
End Function

Function CheckF(x,y,mx,my,cc=0)
	Local n.kist,cf
	If Not cc Then
		For n = Each kist
			If n\x=x+mx And n\y=y+my Then
				cf = CheckF(n\x,n\y,mx,my,1)
				If cf Then PlaySound(hit):m(n\x,n\y)=0
				n\x=n\x+(mx*cf)
				n\y=n\y+(my*cf)
				If Not cf Then Return 0:Else Return 1
			End If
		Next
	EndIf
	If m(x+mx,y+my) = 1 Then Return 0
	Return 1
End Function

Function CWin()
	Local z.ziel,g,n.kist,b=1
	For z = Each ziel
		g=0
		For n = Each kist
			If n\x = z\x And n\y = z\y Then
				g=1
				Color 50,50,100
				Rect n\x*Ts,n\y*Ts,Ts,Ts
			EndIf
		Next
		If g=0 Then b=0
	Next
	Return b
End Function

Type kist
	Field x,y
End Type

Function Nkist(x,y)
	Local n.kist = New kist
	n\x = x
	n\y = y
End Function

Type ziel
	Field x,y
End Type

Function NZiel(x,y)
	Local z.ziel = New ziel
	z\x = x
	z\y = y
End Function

Function LoadLevel(n$)
	Local f = ReadFile("lvl\"+n+".map")
	Local rl$,ln,md$,j,x=-1,y=-1
	Repeat
		rl = ReadLine(f)
		ln = Len(rl)
		y=y+1
		x=-1
		For j = 1 To ln
			x=x+1
			md = Mid(rl,j,1)
			Select md
				Case "#"
					m(x,y)=1
				Case "$"
					Nkist(x,y)
				Case "."
					NZiel(x,y)
				Case "*"
					Nkist(x,y)
					NZiel(x,y)
				Case "@"
					px = x
					py = y
			End Select
		Next
	Until Eof(f)
	CloseFile f
End Function

Function Reset(res=0)
	Delete Each kist
	Delete Each ziel
	Local x,y
	For x = 0 To MW-1
		For y = 0 To MH-1
			m(x,y)=0
		Next
	Next
	px=1
	py=1
	If res = 1 Then Return 0
	level=level+1
	If level>maxlvl Then
		FlushKeys()
		Repeat
			Text Gw/2,5,"you won!",1,1
			If KeyDown(1) Then End
			Flip
			Cls
		Forever
	End If
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D